<?php
	// Widgets function
	if ( function_exists('register_sidebar') )
	register_sidebar(array(
		'name' => 'Left Sidebar',
        'before_widget' => '<div class="widget">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>',
    ));

	register_sidebar(array(
		'name' => 'Right Sidebar',
        'before_widget' => '<div class="widget">',
        'after_widget' => '</div>',
    	'before_title' => '<h3>',
    	'after_title' => '</h3>',
	));

	// "Unwidgetized" Recent Comments
	function recent_comments($count) {
		global $wpdb, $comments, $comment;

		if ( !$number = (int) $count )
			$number = 5;
		else if ( $number < 1 )
			$number = 1;
		else if ( $number > 15 )
			$number = 15;

		if ( !$comments = wp_cache_get( 'recent_comments', 'widget' ) ) {
			$comments = $wpdb->get_results("SELECT comment_author, comment_author_url, comment_ID, comment_post_ID FROM $wpdb->comments WHERE comment_approved = '1' ORDER BY comment_date_gmt DESC LIMIT $number");
			wp_cache_add( 'recent_comments', $comments, 'widget' );
		}
	?>

	<?php
		if ( $comments ) : foreach ($comments as $comment) :
			echo  '<li class="recentcomments">' . sprintf(__('%1$s on %2$s'), get_comment_author_link(), '<a href="'. get_permalink($comment->comment_post_ID) . '#comment-' . $comment->comment_ID . '">' . get_the_title($comment->comment_post_ID) . '</a>') . '</li>';
		endforeach; endif;
	?>
	<?php
	}
	

	// Suckerfish Dropdown Mod
	// My page walker class
	class Menu_Walker extends Walker {
		var $tree_type = 'page';
		var $db_fields = array ('parent' => 'post_parent', 'id' => 'ID'); //TODO: decouple this

		function start_lvl($output, $depth) {
			$indent = str_repeat("\t", $depth);
			$output .= "\n$indent<ul>\n";
			return $output;
		}

		function end_lvl($output, $depth) {
			$indent = str_repeat("\t", $depth);
			$output .= "$indent</ul>\n";
			return $output;
		}

		function start_el($output, $page, $depth, $current_page, $args) {
			if ( $depth )
				$indent = str_repeat("\t", $depth);
			extract($args, EXTR_SKIP);
			$css_class = 'page_item page-item-'.$page->ID;
			$_current_page = get_page( $current_page );
			if ( $page->ID == $current_page )
				$css_class .= ' current_page_item ';
			elseif ( $_current_page && $page->ID == $_current_page->post_parent )
				$css_class .= ' current_page_parent';

			$parent = get_post_meta($page->ID, 'parent', true);
			if ( $parent == '1' )
				$link_class = ' class="parent"';
			
			$output .= $indent . '<li class="' . $css_class . '"><a'.$link_class.' href="' . get_page_link($page->ID) . '" title="' . attribute_escape(apply_filters('the_title', $page->post_title)) . '">' . apply_filters('the_title', $page->post_title) . '</a>';

			if ( !empty($show_date) ) {
				if ( 'modified' == $show_date )
					$time = $page->post_modified;
				else
					$time = $page->post_date;

				$output .= " " . mysql2date($date_format, $time);
			}

			return $output;
		}

		function end_el($output, $page, $depth) {
			$output .= "$indent</li>\n";

			return $output;
		}

	}

	// Custom hack of the wp_list_pages functions to build top menu
	function walk_menu() {
		$walker = new Menu_Walker;
		$args = func_get_args();
		return call_user_func_array(array(&$walker, 'walk'), $args);
	}

	function pages_menu($args = '') {
		$defaults = array(
			'depth' => 0, 'show_date' => '',
			'date_format' => get_option('date_format'),
			'child_of' => 0, 'exclude' => '',
			'title_li' => '', 'echo' => 1,
			'authors' => '', 'sort_column' => 'menu_order, post_title'
		);

		$r = wp_parse_args( $args, $defaults );
		extract( $r, EXTR_SKIP );

		$output = '';
		$current_page = 0;
		
		// sanitize, mostly to keep spaces out
		$r['exclude'] = preg_replace('[^0-9,]', '', $r['exclude']);

		// Allow plugins to filter an array of excluded pages
		$r['exclude'] = implode(',', apply_filters('wp_list_pages_excludes', explode(',', $r['exclude'])));

		// Query pages.
		$pages = get_pages($r);

		if ( !empty($pages) ) {
			$output .= "<ul id=\"navlist\">\n";
			if (is_home()) {
				$output .= "<li class=\"page_item current_page_item\"><a href=\"".get_bloginfo('url')."\" title=\"Home\">Home</a></li>\n";
			} else {
				$output .= "<li class=\"page_item\"><a href=\"".get_bloginfo('url')."\" title=\"Home\">Home</a></li>\n";
			}

			global $wp_query;
			if ( is_page() )
				$current_page = $wp_query->get_queried_object_id();
				$output .= walk_menu($pages, $r['depth'], $current_page, $r);

			$output .= "</ul>";
		}

		$output = apply_filters('wp_list_pages', $output);

		if ( $r['echo'] )
			echo $output;
		else
			return $output;
	}
	
?>